--CalcWindow.lua
--Orignially Calculator.Window written by Willby
--Tweaked by Davinna
-- v1.2

-- define global functions
InCalcWindow = class( Turbine.UI.Lotro.Window )

--define globals variables
memory = 0
idOperation = 0--0: none, 1: addition, 2: substraction, 3: multiplication, 4: division
state = 0 --0 = right after =, 1 = you can concatenate, 3 = right after operation
showResult = false
change = false
windowSettings = { }

function InCalcWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self )
	
	--self:LoadSettings()
	self.Strings = DavsPlugins.InCalc.Utils.GetLanguageStrings()
	self:LoadSettings(self.Strings)
	DavsPlugins.InCalc.Utils.ShowHideUI(self, windowSettings.WindowShowOnStart)
		
	--Window properties
	self:SetBackColor( Turbine.UI.Color() )
	self:SetSize(280, 330)
	self:SetText(self.Strings["Title"])
	
	self:SetPosition( windowSettings.WindowX, windowSettings.WindowY )
	self:SetVisible(windowSettings.WindowShowOnStart)
	self:SetOpacity(windowSettings.CalcOpacity)
			
	--Result label
	self.resultLabel = Turbine.UI.TextBox()
	self.resultLabel:SetEnabled(False)
	self.resultLabel:SetParent( self )
	self.resultLabel:SetPosition( 20, 45 )
	self.resultLabel:SetSize( 240, 40 )
	self.resultLabel:SetBackColor( customBackColor)
	self.resultLabel:SetForeColor( customForeColor )
	self.resultLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight )
	self.resultLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
	self.resultLabel:SetText( "")
	self.resultLabel:SetVisible( true )
	self.resultLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
	
	--Calculator window opacity slider
	local calculatorScrollBar = Turbine.UI.Lotro.ScrollBar()
	calculatorScrollBar:SetParent( self )
	calculatorScrollBar:SetPosition( 20, 300 )
	calculatorScrollBar:SetSize( 240, 7 )
	calculatorScrollBar:SetMinimum( 20)
	calculatorScrollBar:SetMaximum( 100 )
	calculatorScrollBar:SetValue( windowSettings.CalcOpacity*100 )
	--[[local ScrollBarToolTip = DavsPlugins.InCalc.Utils.MakeToolTip(calculatorScrollBar, self.Strings["calcSliderTooltip"])
	
	calculatorScrollBar.MouseMove = function(sender, args)
		Turbine.Shell.WriteLine("move")
		ScrollBarToolTip:SetVisible(false)
	end--hover
	
	calculatorScrollBar.MouseHover = function(sender,args)
		Turbine.Shell.WriteLine("hover")
		if self:IsVisible() then			
			ScrollBarToolTip:SetPosition(100, 100)
			ScrollBarToolTip:SetVisible(true)
		end--if	
	end--mouse hover]]
	
	calculatorScrollBar.ValueChanged = function(sender, args)
		windowSettings.CalcOpacity = tonumber(calculatorScrollBar:GetValue()/100)
		self:SetOpacity(windowSettings.CalcOpacity)
	end
	
	--Number Buttons
	self.button1 = CustomButton( 1 )
	self.button1:SetParent( self )
	self.button1:SetPosition( 20, 205 )
	self.button1.Click = function( sender, args )
		self:Add(1)
    end
	
	self.button2 = CustomButton( 2 )
	self.button2:SetParent( self )
	self.button2:SetPosition( 70, 205 )
	self.button2.Click = function( sender, args )
		self:Add(2)
    end
	
	self.button3 = CustomButton( 3 )
	self.button3:SetParent( self )
	self.button3:SetPosition( 120, 205 )
	self.button3.Click = function( sender, args )
		self:Add(3)
    end
	
	self.button4 = CustomButton( 4 )
	self.button4:SetParent( self )
	self.button4:SetPosition( 20, 155)
	self.button4.Click = function( sender, args )
		self:Add(4)
    end
	
	self.button5 = CustomButton( 5 )
	self.button5:SetParent( self )
	self.button5:SetPosition( 70, 155)
	self.button5.Click = function( sender, args )
		self:Add(5)
    end
	
	self.button6 = CustomButton( 6 )
	self.button6:SetParent( self )
	self.button6:SetPosition( 120, 155)
	self.button6.Click = function( sender, args )
		self:Add(6)
    end
	
	self.button7 = CustomButton( 7 )
	self.button7:SetParent( self )
	self.button7:SetPosition( 20, 105)
	self.button7.Click = function( sender, args )
		self:Add(7)
    end
	
	self.button8 = CustomButton( 8 )
	self.button8:SetParent( self )
	self.button8:SetPosition( 70, 105)
	self.button8.Click = function( sender, args )
		self:Add(8)
    end
	
	self.button9 = CustomButton( 9 )
	self.button9:SetParent( self )
	self.button9:SetPosition( 120, 105)
	self.button9.Click = function( sender, args )
		self:Add(9)
    end
	
	self.button0 = CustomButton( 0 )
	self.button0:SetParent( self )
	self.button0:SetSize( 90, 40 )
	self.button0:SetPosition( 20, 255 )
	self.button0.Click = function( sender, args )
		self:Add(0)
    end
	
	self.buttonDot = CustomButton( self.Strings["decimal"] )
	self.buttonDot:SetParent( self )
	self.buttonDot:SetPosition( 120,255)
	self.buttonDot.Click = function( sender, args )
		self:Add(self.Strings["decimal"])
    end
	
	self.buttonReturn = CustomButton( "<<" )
	self.buttonReturn:SetParent( self )
	self.buttonReturn:SetPosition( 220,105)
	self.buttonReturn.Click = function( sender, args )
		self:Return()
	end
	
	self.btnAddition = CustomButton( "+" )
	self.btnAddition:SetParent( self )
	self.btnAddition:SetPosition( 170,255)
	self.btnAddition.Click = function ( sender, args )
		self:DoOperation()
		operation = 1
	end
	
	self.btnSubstraction = CustomButton( "-" )
	self.btnSubstraction:SetParent( self )
	self.btnSubstraction:SetPosition( 170, 205 )
	self.btnSubstraction.Click = function ( sender, args )
		self:DoOperation()
		operation = 2
	end
	
	self.btnMultiplication = CustomButton( "*" )
	self.btnMultiplication:SetParent( self )
	self.btnMultiplication:SetPosition( 170, 155 )
	self.btnMultiplication:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter )
	self.btnMultiplication.Click = function ( sender, args )
		self:DoOperation()
		operation = 3
	end
	
	self.btnDivision = CustomButton( "/" )
	self.btnDivision:SetParent( self )
	self.btnDivision:SetPosition( 170, 105 )
	self.btnDivision.Click = function ( sender, args )
		self:DoOperation()
		operation = 4
	end
	
	self.btnEquals = CustomButton( "=" )
	self.btnEquals:SetParent( self )
	self.btnEquals:SetSize( 40, 90 )
	self.btnEquals:SetPosition( 220, 205 )
	self.btnEquals.Click = function ( sender, args )
		self:DoOperation()
		operation = 0
		showResult = false
		self.resultLabel:SetText( memory )
		state = 0
	end
	
	self.btnClear = CustomButton( "C" )
	self.btnClear:SetParent( self )
	self.btnClear:SetPosition( 220, 155)
	self.btnClear.Click = function ( sender, args )
		memory = ""
		operation = 0
		self.resultLabel:SetText( memory )
	end
	
end--of constructor

function InCalcWindow:LoadSettings(localString)
	--set defaults
	local displayWidth, displayHeight = Turbine.UI.Display.GetSize()
	local windowWidth, windowHeight = self:GetSize()
	--default postion for calculator
	local cWidth = (displayWidth - windowWidth )-300
	local cHeight = (displayHeight - windowHeight )-500
	--default position for toggle button
	local iWidth = (displayWidth - windowWidth ) -75
	local iHeight = (displayHeight - windowHeight ) -75
	--default opacity
	local cOpacity = 0.9
	local iOpacity = 0.8
	
	windowSettings = Turbine.PluginData.Load( Turbine.DataScope.Server, "InCalcSettings" )
	
	if type( windowSettings ) ~= "table" then
		windowSettings = { 	WindowX = cWidth, 
							WindowY = cHeight,
							WindowShowOnStart = false,
							CalcOpacity = cOpacity,
							IconX = iWidth,
							IconY = iHeight,
							IconShowOnStart = true,
							IconOpacity = iOpacity
							 }
							
	else
		if windowSettings.WindowX == nil then
			windowSettings.WindowX = cWidth
		end
		if windowSettings.WindowY == nil then
			windowSettings.WindowY = cHeight
		end
		if windowSettings.WindowShowOnStart == nil then
			windowSettings.WindowShowOnStart = false
		end
		if windowSettings.CalcOpacity == nil or 0 == windowSettings.CalcOpacity then
			windowSettings.CalcOpacity = cOpacity
		end
		if windowSettings.IconX == nil then
			windowSettings.IconX = iWidth
		end
		if windowSettings.IconY == nil then
			windowSettings.IconY = iHeight
		end
		if windowSettings.IconShowOnStart == nil then
			windowSettings.IconShowOnStart = true
		end
		if windowSettings.IconOpacity == nil or 0 == windowSettings.IconOpacity then
			windowSettings.IconOpacity = iOpacity
		end
	end
	Turbine.Shell.WriteLine( localString["loaded"] )
end


function InCalcWindow:SaveSettings( )
	--get the current calculator position
	windowSettings.WindowX,	windowSettings.WindowY = self:GetPosition()
	Turbine.PluginData.Save( Turbine.DataScope.Server, "InCalcSettings", windowSettings )
	Turbine.Shell.WriteLine( self.Strings["saved"] )
end

--save when unloading
plugin.Unload = function(sender, args)	
	calculator:SaveSettings( )
end

--Tell the user about the cmd
function InCalcWindow:Closing( sender,args )
	self:SaveSettings()
	Turbine.Shell.WriteLine(self.Strings["useCmdn"])
end

--Math Operations 
function InCalcWindow:DoOperation()
	if change == true then
		if operation == 0 then
			memory = self.resultLabel:GetText()
		elseif operation == 1 then
			memory = memory + self.resultLabel:GetText()
		elseif operation == 2 then
			memory = memory - self.resultLabel:GetText()
		elseif operation == 3 then
			memory = memory * self.resultLabel:GetText()
		elseif operation == 4 then
			memory = memory / self.resultLabel:GetText()
		else --nil value
			memory = self.resultLabel:GetText()
		end
		
		sr = ""
		ch = ""
		if showResult == true then sr = "true" else sr = "false" end
		if change == true then ch = "true" else ch = "false" end
		
		state = 3
		change = false
	end
	
	if showResult == true then
		self.resultLabel:SetText( memory )
	else
		showResult = true
	end
end

function InCalcWindow:Add(number)
	if number == self.Strings["decimal"] then
		if state ~= 1 then
			self.resultLabel:SetText( "0"..number )
			state = 1
		else
			if string.find( self.resultLabel:GetText(), self.Strings["decimal"], 1, true ) == nil then
				self.resultLabel:SetText( self.resultLabel:GetText()..number )
			end
		end
	elseif number == 0 then
		if self.resultLabel:GetText() ~= "0" then
			if state ~= 1 then
				self.resultLabel:SetText( number )
			else
				self.resultLabel:SetText( self.resultLabel:GetText()..number )
				state = 1
			end
		end
	else
		if self.resultLabel:GetText() == "0" or state ~= 1 then
			self.resultLabel:SetText( number )
			if state ~= 1 then 
				state = 1
			end
		else
			self.resultLabel:SetText( self.resultLabel:GetText()..number )
		end
	end
	change = true
end

function InCalcWindow:Return()
	if self.resultLabel:GetText() ~= "0" and state ~= 3 then
		if string.len( self.resultLabel:GetText() ) == 1 then
			self.resultLabel:SetText("")
		else
			self.resultLabel:SetText( string.sub( self.resultLabel:GetText(), 1, string.len( self.resultLabel:GetText() ) - 1 ) )
		end
		state = 1
		
		change = true
	end
end