-- DavsUtils.lua
-- Written by Davinna
-- v1.2
--import "Turbine.UI"
--import "Turbine.UI.Lotro"
MakeToolTip = class(Turbine.UI.Window)

function GetLanguageStrings()

--[[#########UTF endcoding info################################
ä	\195\164	Jäger = J\195\164ger
Ä	\195\132	Ärger = \195\132rger
ö	\195\182	schön = sch\195\182n
Ö	\195\150	Ödipus = \195\150dipus
ü	\195\188	Rüstung = R\195\188stung
Ü	\195\156	Übung = \195\156bung
ß	\195\159	Straße = Stra\195\159e 

UTF-8 character encoding table
http://www.utf8-chartable.de/

-- -*- coding: utf-8 -*-
-- write some UTF-8 chars <khman@users.sf.net> 20061017 public domain
-- (see Markus Kuhn's UTF-8 and Unicode FAQ or RFC3629 for more info)
function UnicodeWriteSomething()
  -- áéïöü C3 A1 C3 A9 C3 AF C3 B6 C3 BC --á = C3 A1 = \195\161
  -- 中文 E4 B8 AD E6 96 87
  -- open a new buffer and set encoding as UTF-8
  scite.Open("")
  editor.CodePage = SC_CP_UTF8
  -- string is in UTF-8
  editor:AppendText("áéïöü\n")
  editor:AppendText("中文\n")
  -- string is encoded as escaped sequences
  editor:AppendText("\195\161\195\169\195\175\195\182\195\188\n")
  editor:AppendText("\228\184\173\230\150\135\n")
end
#########################################
]]	
	--determine language
	local clientLanguage = "en"
	local InCalcStrings = {}
	
	if Turbine.Shell.IsCommand("hilfe") then
	  clientLanguage = "de"
	elseif Turbine.Shell.IsCommand("aide") then
	  clientLanguage = "fr"
	end
	
	if clientLanguage == "en" then--english
		InCalcStrings["isOpen"] = "The InCalc window is already open"
		InCalcStrings["useCmdn"] = "Use command /calc to re-open InCalc"
		InCalcStrings["Title"] = "Calculator"
		InCalcStrings["calcSliderTooltip"] = "Move the slider to adjust the opacity of the Calculator"
		InCalcStrings["loaded"] = "InCalc: Settings loaded" 
		InCalcStrings["saved"] = "InCalc: Settings saved"
		InCalcStrings["iconTooltip"] = "Right-click to open Calculator"
		InCalcStrings["showCalc"] = " Show Calculator on Start"
		InCalcStrings["showCalcTooltip"] = "Check this box if you want the calculator to appear when you start the game"
		InCalcStrings["showIcon"] = " Enable Calculator Show/Hide Icon"
		InCalcStrings["showIconTooltip"] = "Check this box if you want the Show/Hide Calculator Icon to appear when you start the game"
		InCalcStrings["iOpacity"] = "Icon opacity:"
		InCalcStrings["iconSliderTooltip"] = "Move the slider to adjust the opacity of the Icon"
		InCalcStrings["decimal"] = "."
	elseif clientLanguage == "de" then--german
		InCalcStrings["isOpen"] = "Das InCalc Fenster ist bereits ge\195\182ffnet."
		InCalcStrings["useCmdn"] = "Das Kommando /calc \195\182ffnet InCalc wieder"
		InCalcStrings["Title"] = "Rechner"--ok
		InCalcStrings["calcSliderTooltip"] = "Schieberegler \195\164ndert die Transparenz des Rechners"
		InCalcStrings["loaded"] = "InCalc: Einstellungen geladen." --ok
		InCalcStrings["saved"] = "InCalc: Einstellungen gespeichert."--ok
		InCalcStrings["iconTooltip"] = "Rechts Klick zum \195\150ffnen des Rechners"
		InCalcStrings["showCalc"] = " Zeigt Rechner beim Start"--ok
		InCalcStrings["showCalcTooltip"] = "Markiere das K\195\164stchen wenn der Rechner bei Spielstart erscheinen soll"
		InCalcStrings["showIcon"] = " Aktiviere das Zeige/Verberge Icon des Rechners"--ok
		InCalcStrings["showIconTooltip"] = "Markiere das K\195\164stchen wenn das Zeige/Verberge Icon des Rechners bei Spielstart erscheinen soll"
		InCalcStrings["iOpacity"] = "Icon Transparenz:"--ok
		InCalcStrings["iconSliderTooltip"] = "Schieberegler \195\164ndert die Transparenz des Icons"
		InCalcStrings["decimal"] = ","--ok
	elseif clientLanguage == "fr" then--french
		InCalcStrings["isOpen"] = "La fenêtre InCalc est déjà ouverte"
		InCalcStrings["useCmd"] = "Utilisez la commande /calc pour ouvrir à nouveau InCalc"
		InCalcStrings["Title"] = "Calculatrice"
		InCalcStrings["calcSliderTooltip"] = "Faites glisser le curseur pour ajuster l'opacité de la Calculatrice"
		InCalcStrings["loaded"] = "InCalc: Réglages chargés" 
		InCalcStrings["saved"] = "InCalc: Réglages sauvegardés"
		InCalcStrings["iconTooltip"] = "Clic droit pour ouvrir la Calculatrice"
		InCalcStrings["showCalc"] = " Afficher la Calculatrice à l'ouverture"
		InCalcStrings["showCalcTooltip"] = "Cochez cette case si vous voulez voir la calculatrice affichée au démarrage du jeu"
		InCalcStrings["showIcon"] = " Activer l'icône Afficher/Cacher la Calculatrice"
		InCalcStrings["showIconTooltip"] = "Cochez cette case si vous voulez que l'icône Afficher/Cacher la Calculatrice apparaisse au démarrage du jeu"
		InCalcStrings["iOpacity"] = "Opacité de l'icône:"
		InCalcStrings["iconSliderTooltip"] = "Faites glisser le curseur pour ajuster l'opacité de l'icône"
		InCalcStrings["decimal"] = ","
	end
		
	return InCalcStrings		
end

-- Show tool tip on mouse hover
function MakeToolTip:Constructor(UIcomponent, ToolTipString)
	Turbine.UI.Window.Constructor(self)
	
	self:SetBackColor( Turbine.UI.Color.Black )
	self:SetOpacity(0.7)	
	
	self.ToolTip = Turbine.UI.Label()
	self.ToolTip:SetParent(self)
	
	self.ToolTip:SetForeColor( Turbine.UI.Color.Goldenrod )
	self.ToolTip:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.ToolTip:SetFontStyle( Turbine.UI.FontStyle.Outline )
	self.ToolTip:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	local index = 14
	self.ToolTip:SetLeft(index) 
		
	if ToolTipString ~= nil then
		self.ToolTip:SetText(ToolTipString)
		self.textsize = string.len(ToolTipString)
		
		local height = 18 --based on font size
		local width = self.textsize*7 --based on font size
		
		if width > 200 then
			local temp = math.ceil(width/200) --truncate to an integer
			height = temp*18
			width = 200
		else
			height = height/2
		end
		
		self:SetSize(width,height)
		self.ToolTip:SetSize(width-index,height)
		--Turbine.Shell.WriteLine("The text is "..ToolTipString)
	else
		--string is empty don't display an empty tool tip
		return
	end
end--make tool tip

-- A function to hide/show the UI when user presses F12
-- Function receives UIComponent - the visible UI component
-- UIShowOnStart - the visible UI component's plugin data 
-- Credit to Chiran author of LotroPad
function ShowHideUI(UIcomponent, UIShowOnStart )

local hideUI = false
local UIWasVisible

	UIcomponent:SetWantsKeyEvents(true)
	
	UIcomponent.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true
				if UIcomponent:IsVisible() then
					UIWasVisible = true
					UIcomponent:SetVisible(false)
				else
					UIWasVisible = false
				end
				--TODO need to test these being commented out
				--button:SetVisible(false)
				--calculator:SetVisible(false)
			else
				hideUI = false
				if UIWasVisible then
					UIcomponent:SetVisible(true)			
				end
				if (UIShowOnStart == true) then
					UIcomponent:SetVisible(true)
				end
			end
		end
	end

end